<?php

    /**
        * Tis file is part of XNova:Legacies
        *
        * @license http://www.gnu.org/licenses/gpl-3.0.txt
        * @see http://www.xnova-ng.org/
        *
        * Copyright (c) 2009-2010, XNova Support Team <http://www.xnova-ng.org>
        * All rights reserved.
        *
        * This program is free software: you can redistribute it and/or modify
        * it under the terms of the GNU General Public License as published by
        * the Free Software Foundation, either version 3 of the License, or
        * (at your option) any later version.
        *
        * This program is distributed in the hope that it will be useful,
        * but WITHOUT ANY WARRANTY; without even the implied warranty of
        * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        * GNU General Public License for more details.
        *
        * You should have received a copy of the GNU General Public License
        * along with this program.  If not, see <http://www.gnu.org/licenses/>.
        *
        *                                --> NOTICE <--
        *  This file is part of the core development branch, changing its contents will
        * make you unable to use the automatic updates manager. Please refer to the
        * documentation for further information about customizing XNova.
        *
    */
    
    function bbcode($text)
    {
        // Transformation du bbcode en HTML
        
        // [b]Texte[/b]        >>> Texte sera en gras 
        $text = preg_replace('#\[b\](.*?)\[/b\]#s', '<strong>$1</strong>', $text);
        
        // [i]Texte[/b]        >>> Texte sera en italique
        $text = preg_replace('#\[i\](.*?)\[/i\]#s', '<em>$1</em>', $text);
        
        // [u]Texte[/u]        >>> Texte sera soulign 
        $text = preg_replace('#\[u\](.*?)\[/u\]#s', '<ins>$1</ins>', $text);
        
        // [s]Texte[/s]        >>> Texte sera barr
        $text = preg_replace('#\[s\](.*?)\[/s\]#s', '<del>$1</del>', $text);
        
        // [q]Texte[/q]        >>> Texte
        $text = preg_replace('#\[q\](.*?)\[/q\]#s', '<q>$1</q>', $text);
        
        //    [list]
        //        [*]Texte 1
        //        [*]Texte 2
        //    [/list]
        $text = preg_replace('/\[list\](.*?)\[\/list\]/ise', 'sList(\'\\1\')', $text);
        
        //     [code]
        //    Texte 1
        //        Texte 2
        //    [/code]        >>> Respecte la mise en forme du texte (retour  la ligne, tabulation, ...) 
        while(preg_match('#\[code\]([^\[]*?)\[/code\]#e', $text))
			$text = preg_replace('#\[code\]([^\[]*?)\[/code\]#e', 'sCode(\'$1\')', $text);
        
        // [quote]Texte[/quote]
		while(preg_match('!\[quote\](.+)\[/quote\]!isU', $text))
			$text = preg_replace('!\[quote\](.+)\[/quote\]!isU', '<fieldset>$1</fieldset>', $text);
        
        // [quote=Utilisateur]Texte[/quote]
		while(preg_match('!\[quote\=(.+)\](.+)\[\/quote\]!isU', $text))
			$text = preg_replace('!\[quote\=(.+)\](.+)\[\/quote\]!isU', '<fieldset><legend>$1 :</legend>$2</fieldset>', $text);
        
        // [url]www.aidexnova.fr[/url]
        $text = preg_replace('#\[url\]([^\[]*?)\[/url\]#e', 'handle_url_tag(\'$1\')', $text);
        
        // [url=www.aidexnova.fr]Forum[/url]
        $text = preg_replace('#\[url=([^\[]*?)\](.*?)\[/url\]#e', 'handle_url_tag(\'$1\', \'$2\')', $text);
        
        // [nospam]mail@nothing.fr[/nospam]        >>> Affichage : mail [A] nothing [.] fr
        // Balise crant un lien pour une adresse de messagerie (adresse partiellement invisible pour les bots)
        $text = preg_replace('#\[nospam\]([^\[]*?)\[/nospam\]#e', 'nospam_tag(\'$1\')', $text);
        
        // [nospam=mail@nothing.fr]Mon adresse de messagerie[/nospam]    >>> Affichage du lien : Mon adresse de messagerie
        // Balise crant un lien pour une adresse de messagerie (adresse totalement invisible pour les bots)
        $text = preg_replace('#\[nospam=([^\[]*?)\](.*?)\[/nospam\]#e', 'nospam_tag(\'$1\', \'$2\')', $text);
        
        // [email]mail@nothing.fr[/email]    >>> Affichage : mail@nothing.fr
        // Balise crant un lien pour une adresse de messagerie (adresse visible pour les bots)
        $text = preg_replace('#\[email\]([^\[]*?)\[/email\]#', '<a href="mailto:$1">$1</a>', $text);
        
        // [email=mail@nothing.fr]Mon adresse de messagerie[/email]        >>> Affichage du lien : Mon adresse de messagerie
        // Balise crant un lien pour une adresse de messagerie (adresse visible pour les bots)
        $text = preg_replace('#\[email=([^\[]*?)\](.*?)\[/email\]#', '<a href="mailto:$1">$2</a>', $text);
        
        // [acronym=World Wide Web Consortium]W3C[/acronym]
        // Balise affichant W3C -> World Wide Web Consortium apparait dans une bulle
        $text = preg_replace('#\[acronym=([^\[]*?)\](.*?)\[/acronym\]#', '<acronym title="$1">$2</acronym>', $text);
        
        // [small]Texte[/small]
        // Balise qui le mot Texte avec une taille plus petite
        $text = preg_replace('#\[small\]([^\[]*?)\[/small\]#', '<span style="font-size: smaller;">$1</span>', $text);
        
        // [large]Texte[/large]
        // Balise qui le mot Texte avec une taille plus grande
        $text = preg_replace('#\[large\]([^\[]*?)\[/large\]#', '<span style="font-size: larger;">$1</span>', $text);
        
        // World Wide Web [sup]Consortium[/sup]
        // Affiche Consortium en tant qu'exposant
        $text = preg_replace('#\[sup\]([^\[]*?)\[/sup\]#', '<sup>$1</sup>', $text);
        
        // World Wide Web [sub]Consortium[/sub]
        // Affiche Consortium en tant qu'indice
        $text = preg_replace('#\[sub\]([^\[]*?)\[/sub\]#', '<sub>$1</sub>', $text);
        
        // [color=red]Texte[/color]
        // Affiche Texte en rouge
        $text = preg_replace('#\[color=([a-zA-Z]*|\#?[0-9a-fA-F]{6})](.*?)\[/color\]#s', '<span style="color: $1">$2</span>', $text);
        
        // La balise [---] affiche une ligne horizontale
        $text = preg_replace('#\[---\]#s', '</p><hr /><p>', $text);
        
        // [left]Texte[/left]
        // Balise qui aligne le texte  gauche
        $text = preg_replace('#\[left\](.*?)\[/left\]#s', '</p><p style="text-align: left">$1</p><p>', $text);
        
        // [right]Texte[/right]
        // Balise qui aligne le texte  droite
        $text = preg_replace('#\[right\](.*?)\[/right\]#s', '</p><p style="text-align: right">$1</p><p>', $text);
        
        // [center]Texte[/center]
        // Balise qui aligne le texte au centre
        $text = preg_replace('#\[center\](.*?)\[/center\]#s', '</p><p style="text-align: center">$1</p><p>', $text);
        
        // [justify]Texte[/justify]
        // Balise qui aligne le texte de manire justifie
        $text = preg_replace('#\[justify\](.*?)\[/justify\]#s', '</p><p style="text-align: justify">$1</p><p>', $text);
        
        return $text;
    }

    function image($string)
    {
        $string = str_replace("'", "'", $string);            
        
        //Emoticones.... COPIEZ COLLEZ CES LIGNES POUR RAJOUTER LES VOTRES !
        $string = str_replace("Smile", "[img]../emoticones/Smile.png[/img]", $string);
        $string = str_replace("cool", "[img]../emoticones/cool.png[/img]", $string);
        $string = str_replace("grrr", "[img]../emoticones/grrr.png[/img]", $string);
        $string = str_replace("love", "[img]../emoticones/love.png[/img]", $string);
        $string = str_replace("msn", "[img]../emoticones/msn.png[/img]", $string);
        $string = str_replace("Oo", "[img]../emoticones/Oo.png[/img]", $string);
        $string = str_replace("perdu", "[img]../emoticones/perdu.png[/img]", $string);
        $string = str_replace("wink", "[img]../emoticones/wink.png[/img]", $string);
        $string = str_replace("wow", "[img]../emoticones/wow.png[/img]", $string);

        return $string;
    }
    
    function sCode($string)
    {
        $pattern =  '/\<img src=\\\"(.*?)img\/smilies\/(.*?).png\\\" alt=\\\"(.*?)\\\" \/>/s';
        $string = preg_replace($pattern, '\3', $string);
        return '<pre>' . trim($string) . '</pre>';
    }
   
    function sList($string)
    {
        $tmp = explode('[*]', stripslashes($string));
        $out = null;
        foreach($tmp as $list)
        {
            if(strlen(str_replace('', '', $list)) > 0)
                $out .= '<li>' . trim($list) . '</li>';
        }
        return '<ul>' . $out . '</ul>';
    }

    //
    // Coupe l'url si la longueur dpasse les 55 caractres
    // Ajoute http:// ou ftp:// si manquant
    //
        
    function handle_url_tag($url, $link = '')
    {
        $full_url = str_replace(array(' ', '\'', '`', '"'), array('%20', '', '', ''), $url);
        if (strpos($url, 'www.') === 0)            // Si  commence par www. => on rajoute http://
            $full_url = 'http://' . $full_url;
        else if (strpos($url, 'ftp.') === 0)    // Si  commence par ftp. => on rajoute ftp://
            $full_url = 'ftp://' . $full_url;
        else if (!preg_match('#^([a-z0-9]{3,6})://#', $url, $bah))     // Dans les autres cas => on rajoute http://
            $full_url = 'http://' . $full_url;
     
        if ($link == '' || $link == $url) 
        {
            if (strlen($url) > 55)
                $link = substr($url, 0 , 39) .' &hellip; ' . substr($url, -10);
            else
                $link = $url;
        }
        else
            $link = stripslashes($link);

        return '<a href="'.$full_url.'">'.$link.'</a>';
    }
        
    //
    // Balise NoSpam
    //
        
    function nospam_tag($email, $text = '')
    {        
        $email_enc = ProtectSpam($email);
        $email = str_replace('@', ' [A] ', $email);
        $email = str_replace('.', ' [.] ', $email);
            
        if ($text == '')
            $text = $email;
                
        return '<a href="mailto:'.$email_enc.'">'.$text.'</a>';
    }
        
    function ProtectSpam($email)
    {
        $Email_Enc = bin2hex($email);
        $Email_Enc = chunk_split($Email_Enc, 2, '%');
        $Email_Enc = '%'.substr($Email_Enc, 0, strlen($Email_Enc) - 1);
        return $Email_Enc;
    }
?>